-- written by DaddelZeit
-- DO NOT USE WITHOUT PERMISSION

local settingsFile = 'settings/zeit/syncRealToGameTime/settings.json'

local M = {}

local isEnabled = "false"

local function getEnabled()
  if isEnabled == "true" then
    return true
  else
    return false
  end
end

local function setEnabled(newVal)
  isEnabled = newVal
  local isEnabledRaw = {
    isEnabled = newVal
  }

  jsonWriteFile(settingsFile, isEnabledRaw, true)
end

local function onExtensionLoaded()
  if FS:fileExists(settingsFile) then
    local isEnabledRaw = readJsonFile(settingsFile)
    isEnabled = isEnabledRaw.isEnabled
  end
end

local function onUpdate()
  if isEnabled == "false" then return end

  local tod = scenetree.tod
  if not tod then return end

  if isEnabled == "true" then
    local minutes = os.date("%H") * 60 + os.date("%M") + os.date("%S") / 60
    local time = (minutes * 6.9444444444444444444444444444444e-4) - 0.5

    tod.time = time
    tod.play = true
  end
end

-- stuff called from the ui javascript
M.setEnabled = setEnabled
M.getEnabled = getEnabled

-- other stuff
M.onUpdate = onUpdate
M.onExtensionLoaded = onExtensionLoaded

return M
